## dmagnetic 0.21

=== debian/changelog ===
dmagnetic (0.21-1) unstable; urgency=medium

  * Update to release 0.21.
  * Some lintian warnings have been removed.
  * Leftover debugging code was creating files
  * dMagnetic is capable of reading MS DOS binaries from more games.

 -- Thomas Dettbarn <dettus@dettus.net>  Sat, 18 Jan 2020 22:43:52 +0100

dmagnetic (0.20-1) unstable; urgency=medium

  * Update to release 0.20.
  * It is possible to play with the original MS DOS binaries
  * A glitch in the text output has been removed.
  * The glitch prevented solving jinxter's sliding puzzle.
  * Changed the standards version to 4.4.1

 -- Thomas Dettbarn <dettus@dettus.net>  Wed, 15 Jan 2020 22:14:42 +0100

dmagnetic (0.19-1) unstable; urgency=medium

  * Update to release 0.19.
  * It is possible to play with the original MS DOS binaries
  * New graphic mode (high_ansi2) for the better looking graphics
  * New random number generator for a different playing experience
  * Changed the standards version to 4.4.1

 -- Thomas Dettbarn <dettus@dettus.net>  Fri, 27 Dec 2019 21:23:45 +0100

dmagnetic (0.18-1) unstable; urgency=medium

  * Update to release 0.18.
  * Removed an issue, where sometimes graphics were not shown.

 -- Thomas Dettbarn <dettus@dettus.net>  Mon, 11 Nov 2019 20:11:47 +0100

dmagnetic (0.17-1) unstable; urgency=medium

  * Update to release 0.17.
  * Removed some warnings from the mentors.debian.net site.
  * Changed the compat level to 12.
  * Changed the standards version to 4.4.0

 -- Thomas Dettbarn <dettus@dettus.net>  Mon, 07 Oct 2019 07:37:59 +0200

dmagnetic (0.16-1) UNRELEASED; urgency=low

  * Initial release. Closes: #929619

 -- Thomas Dettbarn <dettus@dettus.net>  Tue, 23 Jul 2019 12:13:30 +0200

## dmagnetic 0.22

=== Makefile ===
#!/bin/sh
#Copyright 2019, dettus@dettus.net
#
#Redistribution and use in source and binary forms, with or without modification,
#are permitted provided that the following conditions are met:
#
#1. Redistributions of source code must retain the above copyright notice, this 
#   list of conditions and the following disclaimer.
#
#2. Redistributions in binary form must reproduce the above copyright notice, 
#   this list of conditions and the following disclaimer in the documentation 
#   and/or other materials provided with the distribution.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
#ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
#WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
#DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE 
#FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
#SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
#OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
#OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

PREFIX?=/usr/local
INSTALLBIN=$(PREFIX)/bin
INSTALLSHARE=$(PREFIX)/share/games
INSTALLMAN=$(PREFIX)/share/man

CC?=gcc
AR?=ar
#CFLAGS=-g -O0
CFLAGS?=-O3
CFLAGS+=-Wall
#CFLAGS+=-Werror
PROJ_HOME=./
INCFLAGS=-I$(PROJ_HOME)src/gui -I$(PROJ_HOME)src/toplevel -I$(PROJ_HOME)src/loader -I$(PROJ_HOME)src/engine/vm68k -I$(PROJ_HOME)src/engine/linea -I$(PROJ_HOME)src/engine/include 
OBJDIR=$(PROJ_HOME)obj/
LINK=$(CC)
LDFLAGS="-L"$(OBJDIR)

SOURCES_LOADER=	\
	src/loader/maggfxloader.c

SOURCES_LINEA=	\
	src/engine/linea/gfx1loader.c	\
	src/engine/linea/gfx2loader.c	\
	src/engine/linea/linea.c

SOURCES_VM68K=	\
	src/engine/vm68k/vm68k.c	\
	src/engine/vm68k/vm68k_decode.c	\
	src/engine/vm68k/vm68k_loadstore.c

SOURCES_GUI=	\
	src/gui/default_callbacks.c	\
	src/gui/default_render.c

SOURCES_TOPLEVEL=	\
	src/toplevel/configuration.c	\
	src/toplevel/dMagnetic.c

OBJ_LOADER=${SOURCES_LOADER:.c=.o}
OBJ_LINEA=${SOURCES_LINEA:.c=.o}
OBJ_VM68K=${SOURCES_VM68K:.c=.o}
OBJ_GUI=${SOURCES_GUI:.c=.o}
OBJ_TOPLEVEL=${SOURCES_TOPLEVEL:.c=.o}

all:	dMagnetic
	strip dMagnetic

clean:
	rm -rf dMagnetic
	rm -rf $(OBJ_LOADER)
	rm -rf $(OBJ_LINEA)
	rm -rf $(OBJ_VM68K)
	rm -rf $(OBJ_GUI)
	rm -rf $(OBJ_TOPLEVEL)

install: all dMagnetic.1 dMagneticini.5
	mkdir -p $(INSTALLBIN)
	mkdir -p $(INSTALLMAN)/man1
	mkdir -p $(INSTALLMAN)/man5
	mkdir -p $(INSTALLSHARE)/dMagnetic

	cp dMagnetic $(INSTALLBIN)
	cp dMagnetic.1 $(INSTALLMAN)/man1
	cp dMagneticini.5 $(INSTALLMAN)/man5
	cp README.txt $(INSTALLSHARE)/dMagnetic
	cp LICENSE.txt $(INSTALLSHARE)/dMagnetic
	cp dMagnetic.ini $(INSTALLSHARE)/dMagnetic


dMagnetic:	$(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)
	$(LINK) -o $@ $(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)

.c.o:
	$(CC) $(CFLAGS) $(CFLAGS_EXTRA) $(INCFLAGS) -c -o $@ $<

=== debian/changelog ===
dmagnetic (0.22-1) unstable; urgency=medium

  * Update to release 0.22.
  * Binaries from the Magnetic Windows system can be used for playing.
  * Sixel mode allows for high resolution images in certain xterms.

 -- Thomas Dettbarn <dettus@dettus.net>  Thu, 13 Feb 2020 18:56:15 +0100

=== debian/control ===
Source: dmagnetic
Section: games
Priority: optional
Maintainer: Thomas Dettbarn <dettus@dettus.net>
Build-Depends: debhelper (>=12)
Rules-Requires-Root: no
Standards-Version: 4.4.1
Homepage: https://www.dettus.net/dMagnetic/

Package: dmagnetic
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},${misc:Depends}
Description: Interpreter to play textadventures from Magnetic Scrolls in glorious ANSI Art
 dMagnetic is a Magnetic Scrolls Interpreter. It allows one to play classic
 text adventures such as "The Pawn", "The Guild of Thieves", "Fish!", "Myth",
 "Jinxter", "Corruption" and "Wonderland" in a terminal window. The beautiful
 graphics are being rendered in glorious ANSI art.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
#export DEB_RULES_REQUIRES_ROOT = ""

%:
	dh $@

#override_dh_auto_install:
#	dh_auto_install -- prefix=/usr

#override_dh_install:
#	dh_install --list-missing -X.pyc -X.pyo
override_dh_auto_install:
	@echo skip install target

=== debian/watch ===
version=3
https://www.dettus.net/dMagnetic dMagnetic_(0.\d*)\.tar\.bz2

## dmagnetic 0.25

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
-#!/bin/sh
-#Copyright 2019, dettus@dettus.net
+#!/usr/bin/make -f 
+#
+#Copyright 2020, dettus@dettus.net
 #
 #Redistribution and use in source and binary forms, with or without modification,
 #are permitted provided that the following conditions are met:
@@ -37,9 +38,12 @@
 INCFLAGS=-I$(PROJ_HOME)src/gui -I$(PROJ_HOME)src/toplevel -I$(PROJ_HOME)src/loader -I$(PROJ_HOME)src/engine/vm68k -I$(PROJ_HOME)src/engine/linea -I$(PROJ_HOME)src/engine/include 
 OBJDIR=$(PROJ_HOME)obj/
 LINK=$(CC)
-LDFLAGS="-L"$(OBJDIR)
+LDFLAGS+="-L"$(OBJDIR)
 
 SOURCES_LOADER=	\
+	src/loader/loader_msdos.c	\
+	src/loader/loader_mw.c		\
+	src/loader/loader_d64.c		\
 	src/loader/maggfxloader.c
 
 SOURCES_LINEA=	\
@@ -54,6 +58,7 @@
 
 SOURCES_GUI=	\
 	src/gui/default_callbacks.c	\
+	src/gui/default_palette.c	\
 	src/gui/default_render.c
 
 SOURCES_TOPLEVEL=	\
@@ -92,8 +97,12 @@
 
 
 dMagnetic:	$(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)
-	$(LINK) -o $@ $(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)
+	$(LINK) $(LDFLAGS) -o $@ $(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)
 
 .c.o:
 	$(CC) $(CFLAGS) $(CFLAGS_EXTRA) $(INCFLAGS) -c -o $@ $<
 
+
+## in case some post-compilation checks are needed
+## if not, please comment out this line
+include ./checks.mk

=== debian/changelog ===
dmagnetic (0.25-2) unstable; urgency=medium

  * Build with -ffloat-store on i386 to fix FTBFS. (Closes: #966525)

 -- Thomas Dettbarn <dettus@dettus.net>  Mon, 03 Aug 2020 00:59:17 +0100

dmagnetic (0.25-1) unstable; urgency=medium

  * Update to release 0.25.
  * Post compilation check improved

  * Internal RGB channels upgraded from 3 to 10 bit.

 -- Thomas Dettbarn <dettus@dettus.net>  Sun, 26 Jul 2020 14:26:01 +0100

dmagnetic (0.24-1) unstable; urgency=medium

  * Update to release 0.24.
  * Commodore 64 binaries can be used for playing.

 -- Thomas Dettbarn <dettus@dettus.net>  Sat, 11 Jul 2020 19:56:07 +0100

dmagnetic (0.23-1) unstable; urgency=medium

  * Update to release 0.23.
  * Introduced new graphic render modes for MS-DOS binaries

 -- Thomas Dettbarn <dettus@dettus.net>  Sun, 07 Jun 2020 23:03:53 +0100

## dmagnetic 0.27

=== Makefile ===
--- 
+++ 
@@ -44,6 +44,7 @@
 	src/loader/loader_msdos.c	\
 	src/loader/loader_mw.c		\
 	src/loader/loader_d64.c		\
+	src/loader/loader_amstradcpc.c	\
 	src/loader/maggfxloader.c
 
 SOURCES_LINEA=	\
@@ -72,7 +73,7 @@
 OBJ_TOPLEVEL=${SOURCES_TOPLEVEL:.c=.o}
 
 all:	dMagnetic
-	strip dMagnetic
+#	strip dMagnetic
 
 clean:
 	rm -rf dMagnetic
@@ -100,7 +101,7 @@
 	$(LINK) $(LDFLAGS) -o $@ $(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)
 
 .c.o:
-	$(CC) $(CFLAGS) $(CFLAGS_EXTRA) $(INCFLAGS) -c -o $@ $<
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_EXTRA) $(INCFLAGS) -c -o $@ $<
 
 
 ## in case some post-compilation checks are needed

## dmagnetic 0.28

=== Makefile ===
--- 
+++ 
@@ -41,10 +41,12 @@
 LDFLAGS+="-L"$(OBJDIR)
 
 SOURCES_LOADER=	\
+	src/loader/loader_common.c	\
 	src/loader/loader_msdos.c	\
 	src/loader/loader_mw.c		\
 	src/loader/loader_d64.c		\
-	src/loader/loader_amstradcpc.c	\
+	src/loader/loader_dsk.c		\
+	src/loader/loader_archimedes.c	\
 	src/loader/maggfxloader.c
 
 SOURCES_LINEA=	\

## dmagnetic 0.29

=== Makefile ===
--- 
+++ 
@@ -47,6 +47,7 @@
 	src/loader/loader_d64.c		\
 	src/loader/loader_dsk.c		\
 	src/loader/loader_archimedes.c	\
+	src/loader/loader_atarixl.c	\
 	src/loader/maggfxloader.c
 
 SOURCES_LINEA=	\

## dmagnetic 0.30

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f 
 #
-#Copyright 2020, dettus@dettus.net
+#Copyright 2021, dettus@dettus.net
 #
 #Redistribution and use in source and binary forms, with or without modification,
 #are permitted provided that the following conditions are met:
@@ -67,6 +67,7 @@
 
 SOURCES_TOPLEVEL=	\
 	src/toplevel/configuration.c	\
+	src/toplevel/dMagnetic_helpscreens.c	\
 	src/toplevel/dMagnetic.c
 
 OBJ_LOADER=${SOURCES_LOADER:.c=.o}
@@ -75,11 +76,11 @@
 OBJ_GUI=${SOURCES_GUI:.c=.o}
 OBJ_TOPLEVEL=${SOURCES_TOPLEVEL:.c=.o}
 
-all:	dMagnetic
+all:	dMagnetic dMagnetic.ini
 #	strip dMagnetic
 
 clean:
-	rm -rf dMagnetic
+	rm -rf dMagnetic dMagnetic.ini
 	rm -rf $(OBJ_LOADER)
 	rm -rf $(OBJ_LINEA)
 	rm -rf $(OBJ_VM68K)
@@ -103,6 +104,9 @@
 dMagnetic:	$(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)
 	$(LINK) $(LDFLAGS) -o $@ $(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)
 
+dMagnetic.ini:	dMagnetic
+	./dMagnetic -helpini >dMagnetic.ini
+
 .c.o:
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_EXTRA) $(INCFLAGS) -c -o $@ $<

=== debian/changelog ===
dmagnetic (0.30-1) unstable; urgency=medium

  * Internal bugfixes
  * Fixed missing picture from 'Fish!' in C64 mode
  * New characters for the monochrome vmode

 -- Thomas Dettbarn <dettus@dettus.net>  Sun, 31 Jan 2021 14:47:30 +0100

dmagnetic (0.29-1) unstable; urgency=medium

  * AtariXL and Atari800 ATR files are used for playing
  * The new graphic mode UTF has been added
  * More users can enjoy the beautiful pictures now

 -- Thomas Dettbarn <dettus@dettus.net>  Thu, 24 Dec 2020 08:59:34 +0100

dmagnetic (0.28-1) unstable; urgency=medium

  * Spectrum128 and Spectrum+3 binaries can be used
  * Acorn Archimedes binaries can be used for playing
  * Some internal bugfixes

 -- Thomas Dettbarn <dettus@dettus.net>  Sat, 28 Nov 2020 12:48:58 +0100

dmagnetic (0.27-1) unstable; urgency=medium

  * Update to release 0.27.
  * Removed a bug that prevented loading game binaries

  * Loads binaries from Amstrad CPC, Commodore64 and MS DOS

 -- Thomas Dettbarn <dettus@dettus.net>  Sun, 01 Nov 2020 19:09:37 +0100

dmagnetic (0.26-1) unstable; urgency=medium

  * Update to release 0.26.
  * Amstrad CPC images in the DSK format can be used

 -- Thomas Dettbarn <dettus@dettus.net>  Sat, 31 Oct 2020 19:51:49 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Thomas Dettbarn <dettus@dettus.net>
 Build-Depends: debhelper (>=12)
 Rules-Requires-Root: no
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://www.dettus.net/dMagnetic/
 
 Package: dmagnetic

## dmagnetic 0.32

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 AR?=ar
 #CFLAGS=-g -O0
 CFLAGS?=-O3
-CFLAGS+=-Wall
+CFLAGS+=-Wall 
 #CFLAGS+=-Werror
 PROJ_HOME=./
 INCFLAGS=-I$(PROJ_HOME)src/gui -I$(PROJ_HOME)src/toplevel -I$(PROJ_HOME)src/loader -I$(PROJ_HOME)src/engine/vm68k -I$(PROJ_HOME)src/engine/linea -I$(PROJ_HOME)src/engine/include 
@@ -48,6 +48,7 @@
 	src/loader/loader_dsk.c		\
 	src/loader/loader_archimedes.c	\
 	src/loader/loader_atarixl.c	\
+	src/loader/loader_appleii.c	\
 	src/loader/maggfxloader.c
 
 SOURCES_LINEA=	\
@@ -87,18 +88,18 @@
 	rm -rf $(OBJ_GUI)
 	rm -rf $(OBJ_TOPLEVEL)
 
-install: all dMagnetic.1 dMagneticini.5
-	mkdir -p $(INSTALLBIN)
-	mkdir -p $(INSTALLMAN)/man1
-	mkdir -p $(INSTALLMAN)/man5
-	mkdir -p $(INSTALLSHARE)/dMagnetic
+install: all dMagnetic.6 dMagneticini.5
+	mkdir -p $(INSTALLBIN)		
+	mkdir -p $(INSTALLMAN)/man6/
+	mkdir -p $(INSTALLMAN)/man5/	
+	mkdir -p $(INSTALLSHARE)/dMagnetic/
 
 	cp dMagnetic $(INSTALLBIN)
-	cp dMagnetic.1 $(INSTALLMAN)/man1
-	cp dMagneticini.5 $(INSTALLMAN)/man5
-	cp README.txt $(INSTALLSHARE)/dMagnetic
-	cp LICENSE.txt $(INSTALLSHARE)/dMagnetic
-	cp dMagnetic.ini $(INSTALLSHARE)/dMagnetic
+	cp dMagnetic.6 $(INSTALLMAN)/man6/
+	cp dMagneticini.5 $(INSTALLMAN)/man5/
+	cp README.txt $(INSTALLSHARE)/dMagnetic/
+	cp LICENSE.txt $(INSTALLSHARE)/dMagnetic/
+	cp dMagnetic.ini $(INSTALLSHARE)/dMagnetic/
 
 
 dMagnetic:	$(OBJ_LOADER) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_GUI) $(OBJ_TOPLEVEL)

=== debian/changelog ===
dmagnetic (0.32-1) unstable; urgency=medium

  * New input format: WOZ
  * Minor bug fixes
  * Minor code cleanup

 -- Thomas Dettbarn <dettus@dettus.net>  Fri, 23 Jul 2021 00:33:15 +0200

dmagnetic (0.31-1) unstable; urgency=medium

  * New input formats: NIB and 2MG
  * Improved Sixel mode
  * New -dumpmag and -dumpgfx command line parameters
  * Moved the manpage to section 6 (games)

 -- Thomas Dettbarn <dettus@dettus.net>  Wed, 23 Jun 2021 23:22:22 +0200

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
ifneq (,$(filter $(DEB_HOST_ARCH), i386))
	export DEB_CFLAGS_MAINT_APPEND += -ffloat-store
endif
export SHA256_CMD=sha256sum

%:
	dh $@


override_dh_auto_install:
	@echo skip install target

## dmagnetic 0.34

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f 
 #
-#Copyright 2021, dettus@dettus.net
+#Copyright 2022, dettus@dettus.net
 #
 #Redistribution and use in source and binary forms, with or without modification,
 #are permitted provided that the following conditions are met:
@@ -34,6 +34,7 @@
 CFLAGS?=-O3
 CFLAGS+=-Wall 
 #CFLAGS+=-Werror
+#CPPFLAGS+=-DEXPERIMENTAL_SAVEGAME_SLOTS
 PROJ_HOME=./
 INCFLAGS=-I$(PROJ_HOME)src/gui -I$(PROJ_HOME)src/toplevel -I$(PROJ_HOME)src/loader -I$(PROJ_HOME)src/engine/vm68k -I$(PROJ_HOME)src/engine/linea -I$(PROJ_HOME)src/engine/include 
 OBJDIR=$(PROJ_HOME)obj/

=== debian/changelog ===
dmagnetic (0.34-1) unstable; urgency=medium

  * Minor bugfixes
  * Slightly updated documentation
  * Popular feature "-nodoc" had an issue with saved games.

 -- Thomas Dettbarn <dettus@dettus.net>  Thu, 28 Apr 2022 15:26:27 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Thomas Dettbarn <dettus@dettus.net>
 Build-Depends: debhelper (>=12)
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 Homepage: https://www.dettus.net/dMagnetic/
 
 Package: dmagnetic

## dmagnetic 0.36

=== Makefile ===
#!/usr/bin/make -f 
#
#Copyright 2023, dettus@dettus.net
#
#Redistribution and use in source and binary forms, with or without modification,
#are permitted provided that the following conditions are met:
#
#1. Redistributions of source code must retain the above copyright notice, this 
#   list of conditions and the following disclaimer.
#
#2. Redistributions in binary form must reproduce the above copyright notice, 
#   this list of conditions and the following disclaimer in the documentation 
#   and/or other materials provided with the distribution.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
#ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
#WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
#DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE 
#FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
#SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
#OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
#OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

PREFIX?=/usr/local
DESTDIR?=$(PREFIX)
MYPREFIX=$(DESTDIR)
INSTALLBIN=$(MYPREFIX)/bin
INSTALLSHARE=$(MYPREFIX)/share/games
INSTALLMAN=$(MYPREFIX)/share/man

CC?=gcc
AR?=ar
#CFLAGS=-g -O0
CFLAGS?=-O3
CFLAGS+=-Wall 
#CFLAGS+=-Werror
#CPPFLAGS+=-DEXPERIMENTAL_SAVEGAME_SLOTS
PROJ_HOME=./
INCFLAGS= -I$(PROJ_HOME)src/frontends/default/ -I$(PROJ_HOME)src/frontends -I$(PROJ_HOME)src/loader -I$(PROJ_HOME)src/libdmagnetic -I$(PROJ_HOME)src/libdmagnetic/vm68k -I$(PROJ_HOME)src/libdmagnetic/linea -I$(PROJ_HOME)src/libdmagnetic/include 
OBJDIR=$(PROJ_HOME)obj/
LINK=$(CC)
LDFLAGS+="-L"$(OBJDIR)

SOURCES_LOADER=	\
	src/loader/loader_appleii.c	\
	src/loader/loader_archimedes.c	\
	src/loader/loader_atarixl.c	\
	src/loader/loader_common.c	\
	src/loader/loader_d64.c		\
	src/loader/loader_dsk.c		\
	src/loader/loader_msdos.c	\
	src/loader/loader_mw.c		\
	src/loader/maggfxloader.c

SOURCES_LIBDMAGNETIC= \
	src/libdmagnetic/dMagnetic.c

SOURCES_LINEA=	\
	src/libdmagnetic/linea/gfx1loader.c	\
	src/libdmagnetic/linea/gfx2loader.c	\
	src/libdmagnetic/linea/linea.c

SOURCES_VM68K=	\
	src/libdmagnetic/vm68k/vm68k.c	\
	src/libdmagnetic/vm68k/vm68k_decode.c	\
	src/libdmagnetic/vm68k/vm68k_loadstore.c


SOURCES_FRONTEND=	\
	src/frontends/default/configuration.c	\
	src/frontends/default/default_callbacks.c	\
	src/frontends/default/default_palette.c	\
	src/frontends/default/default_render.c	\
	src/frontends/default/helpscreens.c	\
	src/frontends/default/main.c

OBJ_LOADER=${SOURCES_LOADER:.c=.o}
OBJ_ENGINE=${SOURCES_LIBDMAGNETIC:.c=.o}
OBJ_LINEA=${SOURCES_LINEA:.c=.o}
OBJ_VM68K=${SOURCES_VM68K:.c=.o}
OBJ_DEFAULT=${SOURCES_FRONTEND:.c=.o}


all:	dMagnetic dMagnetic.ini
#	strip dMagnetic

clean:
	rm -rf dMagnetic dMagnetic.ini libdmagnetic.a
	rm -rf $(OBJ_LOADER)
	rm -rf $(OBJ_ENGINE)
	rm -rf $(OBJ_LINEA)
	rm -rf $(OBJ_VM68K)
	rm -rf $(OBJ_DEFAULT)

install: all dMagnetic.6 dMagneticini.5
	install -m 755 -d $(INSTALLBIN)
	install -m 755 -d $(INSTALLMAN)/man5/
	install -m 755 -d $(INSTALLMAN)/man6/
	install -m 755 -d $(INSTALLSHARE)/dMagnetic/

	install -m 755 -s dMagnetic $(INSTALLBIN)/dMagnetic
	install -m 644 dMagneticini.5 $(INSTALLMAN)/man5/dMagneticini.5
	install -m 644 dMagnetic.6 $(INSTALLMAN)/man6/dMagnetic.6
	install -m 644 README.txt $(INSTALLSHARE)/dMagnetic/README.txt
	install -m 644 LICENSE.txt $(INSTALLSHARE)/dMagnetic/LICENSE.txt
	cp dMagnetic.ini $(INSTALLSHARE)/dMagnetic/


dMagnetic:	$(OBJ_LOADER) $(OBJ_DEFAULT)  $(OBJ_ENGINE) $(OBJ_LINEA) $(OBJ_VM68K)
	$(LINK) $(LDFLAGS) -o $@ $(OBJ_LOADER)  $(OBJ_ENGINE) $(OBJ_LINEA) $(OBJ_VM68K) $(OBJ_DEFAULT)

dMagnetic.ini:	dMagnetic
	./dMagnetic -helpini >dMagnetic.ini

.c.o:
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_EXTRA) $(INCFLAGS) -c -o $@ $<


# initial inkling for a dmagnetic backend library
libdmagnetic.a:	$(OBJ_ENGINE) $(OBJ_LINEA) $(OBJ_VM68K)
	$(AR) rs libdmagnetic.a $(OBJ_ENGINE) $(OBJ_LINEA) $(OBJ_VM68K)	


## in case some post-compilation checks are needed
## if not, please comment out this line
include ./checks.mk

=== debian/changelog ===
dmagnetic (0.36-1) unstable; urgency=medium

  * Minor bugfixes
  * Backend engine can be encapsulated in a library
  * HelloWorld example for interested frontend developers

 -- Thomas Dettbarn <dettus@dettus.net>  Sat, 28 Jan 2023 22:52:19 +0200

dmagnetic (0.35-1) unstable; urgency=medium

  * Minor bugfixes
  * Reduced memory consumption
  * New default format for savegames
  * Better looking ANSI and ASCII output
  * Much cleaner sourcecode

 -- Thomas Dettbarn <dettus@dettus.net>  Tue, 24 Jan 2023 21:34:56 +0200

## dmagnetic 0.37

=== Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 #OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 PREFIX?=/usr/local
-DESTDIR?=$(PREFIX)
+DESTDIR?=/usr/local
 MYPREFIX=$(DESTDIR)
 INSTALLBIN=$(MYPREFIX)/bin
 INSTALLSHARE=$(MYPREFIX)/share/games
@@ -58,8 +58,7 @@
 	src/libdmagnetic/dMagnetic.c
 
 SOURCES_LINEA=	\
-	src/libdmagnetic/linea/gfx1loader.c	\
-	src/libdmagnetic/linea/gfx2loader.c	\
+	src/libdmagnetic/linea/gfxloader.c	\
 	src/libdmagnetic/linea/linea.c
 
 SOURCES_VM68K=	\

=== debian/changelog ===
dmagnetic (0.37-1) unstable; urgency=medium

  * Minor bugfixes
  * Reduced memory consumption
  * Better help screens

 -- Thomas Dettbarn <dettus@dettus.net>  Tue, 16 May 2023 22:54:49 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: games
 Priority: optional
 Maintainer: Thomas Dettbarn <dettus@dettus.net>
-Build-Depends: debhelper (>=12)
+Build-Depends: debhelper-compat ( = 13)
 Rules-Requires-Root: no
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Homepage: https://www.dettus.net/dMagnetic/
 
 Package: dmagnetic

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,6 @@
 export DH_VERBOSE = 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-ifneq (,$(filter $(DEB_HOST_ARCH), i386))
-	export DEB_CFLAGS_MAINT_APPEND += -ffloat-store
-endif
 export SHA256_CMD=sha256sum
 
 %:

=== debian/watch ===
version=4
https://www.dettus.net/dMagnetic dMagnetic_(0.\d*)\.tar\.bz2
